#!/bin/sh

#if [ -z $1 ]; then
#  echo "Usage: ./deploy.sh <COMMON NAME>"
#  exit
#fi


INTERFACE=wlan0
#INTERFACE=enp7s0

if [ -z $INTERFACE ]; then
  echo "Please enter your ethernet interface"
  exit
fi

hwaddr=$(ifconfig -a | grep $INTERFACE | awk '{print tolower($5)}')
DeviceId="${hwaddr//:/}"

echo Devive ID is $DeviceId 

if [ -d /etc/opt/ca ]; then
  echo "File exist. Abort!!"
  exit
fi





printf "\n\n\n\n\n$DeviceId\n\n\n\n" | openssl req -newkey rsa:2048 -out leaf-csr.pem -nodes -keyout leaf-key.pem -config openssl.cnf 

openssl x509 -req -days 3650 -in leaf-csr.pem \
  -CA ./root-ca.pem -CAkey ./root-key.pem \
  -CAcreateserial -out leaf-ca.pem


mkdir -p ca
mv leaf-ca.pem ca/
mv leaf-key.pem ca/
rm leaf-csr.pem
echo $DeviceId > ca/CN
echo -e "\033[1;34mGenerate device CA successfully"
echo ""

mv ca /etc/opt/
